// testview.cpp : implementation of the CTestView class
//

#include "stdafx.h"
#include "test.h"

#include "testdoc.h"
#include "testview.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTestView

IMPLEMENT_DYNCREATE(CTestView, CFormView)

BEGIN_MESSAGE_MAP(CTestView, CFormView)
	//{{AFX_MSG_MAP(CTestView)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestView construction/destruction

CTestView::CTestView()
	: CFormView(CTestView::IDD)
{
	//{{AFX_DATA_INIT(CTestView)
	m_MeterBar4 = NULL;
	m_MeterBar3 = NULL;
	m_MeterBar2 = NULL;
	m_MeterBar1 = NULL;
	//}}AFX_DATA_INIT
	// TODO: add construction code here
}

CTestView::~CTestView()
{
}

void CTestView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestView)
	DDX_VBControl(pDX, IDC_METERBAR4, m_MeterBar4);
	DDX_VBControl(pDX, IDC_METERBAR3, m_MeterBar3);
	DDX_VBControl(pDX, IDC_METERBAR2, m_MeterBar2);
	DDX_VBControl(pDX, IDC_METERBAR1, m_MeterBar1);
	//}}AFX_DATA_MAP
}

/////////////////////////////////////////////////////////////////////////////
// CTestView diagnostics

#ifdef _DEBUG
void CTestView::AssertValid() const
{
	CFormView::AssertValid();
}

void CTestView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CTestDoc* CTestView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CTestDoc)));
	return (CTestDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CTestView drawing routines

void CTestView::OnDraw(CDC *pDC)
{
	CRect rect;
	CBrush brush(::GetSysColor(COLOR_BTNFACE));
	
	GetClientRect(rect);
	pDC->FillRect(rect, &brush);
}

/////////////////////////////////////////////////////////////////////////////
// CTestView message handlers

int CTestView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CFormView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	::SetTimer(m_hWnd, 1, 250, NULL);
	
	return 0;
}

void CTestView::OnDestroy() 
{
	CFormView::OnDestroy();
	
	::KillTimer(m_hWnd, 1);
}

void CTestView::OnTimer(UINT nIDEvent) 
{
	LONG pos, ran;
	
	// do first meter bar control
	pos = m_MeterBar1->GetNumProperty("Position");
	ran = m_MeterBar1->GetNumProperty("Range");
	pos++;
	if (pos > ran)
		pos = 0;
	m_MeterBar1->SetNumProperty("Position", pos);

	// do next meter bar control
	pos = m_MeterBar2->GetNumProperty("Position");
	ran = m_MeterBar2->GetNumProperty("Range");
	pos++;
	if (pos > ran)
		pos = 0;
	m_MeterBar2->SetNumProperty("Position", pos);

	// do next meter bar control
	pos = m_MeterBar3->GetNumProperty("Position");
	ran = m_MeterBar3->GetNumProperty("Range");
	pos++;
	if (pos > ran)
		pos = 0;
	m_MeterBar3->SetNumProperty("Position", pos);

	// do next meter bar control
	pos = m_MeterBar4->GetNumProperty("Position");
	ran = m_MeterBar4->GetNumProperty("Range");
	pos++;
	if (pos > ran)
		pos = 0;
	m_MeterBar4->SetNumProperty("Position", pos);
}
